# socketsrc

Receive data from a socket.

As compared to other elements:

socketsrc can be considered a source counterpart to the GstMultiSocketSink sink.

socketsrc can also be considered a generalization of tcpclientsrc and tcpserversrc: it contains all the logic required to communicate over the socket but none of the logic for creating the sockets/establishing the connection in the first place, allowing the user to accomplish this externally in whatever manner they wish making it applicable to other types of sockets besides TCP.

As compared to fdsrc socketsrc is socket specific and deals with GSocket objects rather than sockets via integer file-descriptors.

see_also: GstMultiSocketSink

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSrc
                        ╰──GstPushSrc
                            ╰──socketsrc

## Factory details

Authors: – Thomas Vander Stichele , William Manley

Classification: – `Source/Network`

Rank – none

Plugin – tcp

Package – GStreamer Base Plug-ins

## Pad Templates

### `src`

    ANY

Presence – always

Direction – src

Object type – GstPad

## Signals

### connection-closed-by-peer

    connection_closed_by_peer_callback (GstElement * param_0,
                                        gpointer udata)

    def connection_closed_by_peer_callback (param_0, udata):
        #python callback for the 'connection-closed-by-peer' signal

    function connection_closed_by_peer_callback(param_0: GstElement * param_0, udata: gpointer udata): {
        // javascript callback for the 'connection-closed-by-peer' signal
    }

Parameters:

`param_0` –
No description available
`udata` –
No description available

Flags: Run First

## Properties

### caps

    “caps” GstCaps *

The caps of the source pad

Flags : Read / Write

### send-messages

    “send-messages” gboolean

Control if the source will handle GstNetworkMessage events. The event is a CUSTOM event named 'GstNetworkMessage' and contains:

"buffer", GST_TYPE_BUFFER : the buffer with data to send

The buffer in the event will be sent on the socket. This allows for simple bidirectional communication.

Flags : Read / Write

Default value : false

Since : 1.8.0

### socket

    “socket” GSocket *

The socket to receive packets from

Flags : Read / Write

The results of the search are